

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import java.util.Set;
import java.util.TreeSet;


public class Calculate_mRNAmiRNA_MFE_list {

	public static String commonPath;
	public static Properties properties;
	
	//TreeSet<String> pairs = new TreeSet<String>();

	Map<String, String> parsedMRNA = new HashMap<String,String>();
	Map<String, String> parsedMiRNA = new HashMap<String,String>();
	
	public double threshold;
	public String filename;
	private String mRNAlist;
	private String miRNAlist;
	private BufferedReader mRNAmiRNA_file; 
	
	

	public Calculate_mRNAmiRNA_MFE_list(String _mRNAlist, String _miRNAlist, String _filename, double _threshold) {
		this.threshold = _threshold;
		this.filename= _filename;
		this.mRNAlist= _mRNAlist;
		this.miRNAlist= _miRNAlist;
	}
	
	private void start() throws IOException {
		parsedMRNA = parseMRNA(commonPath+mRNAlist);
		parsedMiRNA = parseMiRNA(commonPath+miRNAlist);

		String row = null;
		
		//FileWriter outputPairs = new FileWriter(commonPath+"Pairs_HeadTail_"+label+".txt"); 
		//mRNAmiRNA_file = new BufferedReader(new FileReader(commonPath+"TailConfirmedTargets_"+label+".txt"));
				

		Runtime rt = Runtime.getRuntime();

		BufferedReader reader = new BufferedReader(new FileReader (commonPath+filename));
		//BufferedReader reader = new BufferedReader(new FileReader (commonPath+"Pairs_HeadTail_hsa4_th0.7_offset3_cut0.57.txt"));
		//FileWriter writerPairsRNAhybrid = new FileWriter(commonPath+"Pairs_HeadTail_RNAhybrid_th"+thresholdRNAHybrid+"_distance"+label+".txt"); 
		FileWriter writerPairsIntaRNA = new FileWriter(commonPath+"Pairs_IntaRNA_th"+threshold+"_"+filename); 
		//System.out.println(offset);
//
		//int rowcount= 0;
		while ((row  = reader.readLine()) != null) {
			//rowcount++;
			//if (rowcount%100 == 0)
			//	System.out.println("row= "+rowcount);
			String[] rowParts = row.split(";");
			String subRowParts[] = rowParts[0].split("_");

			String mRNAAnnotation = subRowParts[0];
			String miRNAAnnotation = rowParts[1];
			int position = Integer.parseInt(subRowParts[1]);

			String fullMRNA = parsedMRNA.get(mRNAAnnotation);

			int start = Math.max(0, position-15-14);
			int lunghezza=fullMRNA.length();
			System.out.println("lunghezza="+lunghezza);
			int end = Math.min(position+8+15, lunghezza);

			String windowMRNA = fullMRNA.substring(start, end);
			String miRNA = parsedMiRNA.get(miRNAAnnotation);


			//Calculate RNAHybrid and intaRNA
			String mfe= new IntaRNAFreeEnergy().getFreeEnergy(windowMRNA, miRNA);
 
			if (mfe== "")
				mfe= "0";
			double mfeTh = Double.parseDouble(mfe);
			//System.out.println(mfeTh);
			if (mfeTh < threshold) {
				writerPairsIntaRNA.write(mRNAAnnotation+"_"+position+","+miRNAAnnotation+","+mfeTh);
				writerPairsIntaRNA.write('\n');
			}

		}

		writerPairsIntaRNA.close();
	}

	
	

	public static void init() throws IOException {
		properties = new Properties();
		properties.load(new FileInputStream("prefs.properties"));
		commonPath = properties.getProperty("commonPath");
	}

		
	
	public static void main(String [] args) throws IOException{
		
		init();
		
		String mRNAlist = args[0];
		String miRNAlist = args[1];
		String filename = args[2];
		double threshold = Double.parseDouble(args[3]);
			
			Calculate_mRNAmiRNA_MFE_list joinMiM= new Calculate_mRNAmiRNA_MFE_list( mRNAlist, miRNAlist, filename, threshold);
 			joinMiM.start();

	} // end main


	public static HashMap<String, String> parseMRNA(String file) {
		HashMap<String,String> result = new HashMap<String,String>();

		BufferedReader seqInput = null;
		String row = "";	
		String sequence = "";
		String MRNA = "";
		try {
			seqInput = new BufferedReader(new FileReader(file));
			while((row = seqInput.readLine())!=null){
				if ((row.indexOf(">")) == -1){
					sequence = sequence + row;
				}
				else {
					if(MRNA.length()!=0) {
						result.put(MRNA, sequence);
						sequence = "";						
					}
					MRNA = row;
				}
			}
			result.put(MRNA, sequence); // aggiunge l'ultima coppia
			seqInput.close();
		} catch (IOException e) {
			throw new RuntimeException("Errore nella lettura!", e);
		}

		return result;
	}

	public static HashMap<String, String> parseMiRNA(String file) {
		HashMap<String,String> result = new HashMap<String,String>();

		BufferedReader seqInput = null;
		String row = "";	
		String sequence = "";
		String MIRNA = "";
		try {
			seqInput = new BufferedReader(new FileReader(file));
			while((row = seqInput.readLine())!=null){
				if ((row.indexOf(">")) == -1){
					sequence = sequence + row;
				}
				else {
					if(MIRNA.length()!=0) {
						result.put(MIRNA, sequence);
						sequence = "";						
					}						
					String[] realKey = row.split(" ");
					MIRNA = realKey[0];
				}
			}
			result.put(MIRNA, sequence); // aggiunge l'ultima coppia
			seqInput.close();
		} catch (IOException e) {
			throw new RuntimeException("Errore nella lettura!", e);
		}

		return result;
	}
	
	
	private static void printAndSave (String s, PrintWriter pw) {
//		System.out.print(s);
		if (pw != null) pw.print(s);
	}
} // end class



