
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import java.util.Set;
import java.util.TreeSet;


public class Create_mRNAmiRNA_list {

	public static String commonPath;
	public static Properties properties;
	

	Map<String, String> parsedMRNA = new HashMap<String,String>();
	Map<String, String> parsedMiRNA = new HashMap<String,String>();
	
	private BufferedReader mRNAmiRNA_file;
	public String mRNAlist;
	public String miRNAlist;
	public String inputFile;
	//private BufferedReader mRNAmiRNA_tail; 
	
	
	
//	public JoinHeadTail_mRNAmiRNA_hsa_linux(int _offset, double th) {
//		
//		this.offset = _offset;
//		this.threshold = th;
//	}

	public Create_mRNAmiRNA_list(String _mRNAList, String _miRNAList, String _inputFile) {
		this.mRNAlist= _mRNAList;
		this.miRNAlist= _miRNAList;
		this.inputFile= _inputFile;
	}
	
	private void start() throws IOException {
		parsedMRNA = parseMRNA(commonPath+mRNAlist);
		parsedMiRNA = parseMiRNA(commonPath+miRNAlist);

 		//pairs = new TreeSet<String>();
		
		String row = null;
		
		try {

			mRNAmiRNA_file = new BufferedReader(new FileReader(commonPath+inputFile));
//			mRNAmiRNA_tail = new BufferedReader(new FileReader(commonPath+"mRNA-miRNA_CalculatorTail_fragment.txt"));
			FileWriter outputPairs = new FileWriter(commonPath+"Pairs_HeadTail_"+ inputFile); 

			int rowcount=0;
			
			while ((row  = mRNAmiRNA_file.readLine()) != null) {
				rowcount++;
				System.out.println("row= "+rowcount);
				String[] rowParts = row.split(";");
				if (rowParts.length != 3 || rowParts[1].isEmpty() || rowParts[2].isEmpty()) continue;
				String[] targets = rowParts[1].split(",");
				String[] miRNAs = rowParts[2].split(",");

				for (String target : targets) {

					String [] splitTarget = target.split("_");
					int positionInt = Integer.parseInt(splitTarget[1]);
					
					int start = Math.max(0, positionInt);
					int end = Math.min(positionInt, parsedMRNA.get(splitTarget[0]).length());

					for(int j = start; j<= end; j++){
						target = splitTarget[0] + "_";
						if (j < 10) target += "0";
						if (j < 100) target += "0";
						target += j;
						//System.out.println("target="+splitTarget[0]+" " +j);
						for (String miRNA : miRNAs) {
							outputPairs.write(target + ";" + miRNA + "\n");
						}
					}
				}
				
			}
			System.out.println("HEAD PAIR LIST created... ");

			outputPairs.close();
	        			
			

		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	
	

	public static void init() throws IOException {
		properties = new Properties();
		properties.load(new FileInputStream("prefs.properties"));
		commonPath = properties.getProperty("commonPath");
	}

		
	
	public static void main(String [] args) throws IOException{
		
		init();
		String mRNAlist = args[0];
		String miRNAlist = args[1];
		String filename = args[2];
			
			Create_mRNAmiRNA_list joinMiM= new Create_mRNAmiRNA_list(mRNAlist, miRNAlist, filename);
 
//			joinMiM.start("th0.7_offset3_cut0.58");
//			joinMiM.start("th0.7_offset3_cut0.57");
			joinMiM.start();

	} // end main


	public static HashMap<String, String> parseMRNA(String file) {
		HashMap<String,String> result = new HashMap<String,String>();

		BufferedReader seqInput = null;
		String row = "";	
		String sequence = "";
		String MRNA = "";
		try {
			seqInput = new BufferedReader(new FileReader(file));
			while((row = seqInput.readLine())!=null){
				if ((row.indexOf(">")) == -1){
					sequence = sequence + row;
				}
				else {
					if(MRNA.length()!=0) {
						result.put(MRNA, sequence);
						sequence = "";						
					}
					MRNA = row;
				}
			}
			result.put(MRNA, sequence); // aggiunge l'ultima coppia
			seqInput.close();
		} catch (IOException e) {
			throw new RuntimeException("Errore nella lettura!", e);
		}

		return result;
	}

	public static HashMap<String, String> parseMiRNA(String file) {
		HashMap<String,String> result = new HashMap<String,String>();

		BufferedReader seqInput = null;
		String row = "";	
		String sequence = "";
		String MIRNA = "";
		try {
			seqInput = new BufferedReader(new FileReader(file));
			while((row = seqInput.readLine())!=null){
				if ((row.indexOf(">")) == -1){
					sequence = sequence + row;
				}
				else {
					if(MIRNA.length()!=0) {
						result.put(MIRNA, sequence);
						sequence = "";						
					}						
					String[] realKey = row.split(" ");
					MIRNA = realKey[0];
				}
			}
			result.put(MIRNA, sequence); // aggiunge l'ultima coppia
			seqInput.close();
		} catch (IOException e) {
			throw new RuntimeException("Errore nella lettura!", e);
		}

		return result;
	}
	
	
	private static void printAndSave (String s, PrintWriter pw) {
//		System.out.print(s);
		if (pw != null) pw.print(s);
	}
} // end class



