
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class IntaRNAFreeEnergy {
	
	 String freeEnergy= "";

    public static void main(String[] args) throws IOException, InterruptedException {
        
        String energy= new IntaRNAFreeEnergy().getFreeEnergy("ACCATGGTACATGATGA", "AACATGGTACATGATGACCCATG" );
		System.out.println("energia libera: " + energy);
        
    }
    

    
    public IntaRNAFreeEnergy() {
	
    }
    

    /**
     *  Call the tool IntaRNA for calculating the Free Energy 
     *  
     * @param seq1 - miRNA sequence
     * @param seq2 - mRNA sequence
     * 
     * @return Free Energy 
     */
    public String getFreeEnergy(String seq1, String seq2){
        Process proc;
       // String intaRNA= "/home/foo/intarna-1.2.5/src/IntaRNA";
	String intaRNA= "IntaRNA";
        
        String output="";
		try {
			proc = Runtime.getRuntime().exec(intaRNA +" "+ seq1 +" "+ seq2 );
		

        // Read the output
        BufferedReader reader =  new BufferedReader(new InputStreamReader(proc.getInputStream()));

        StringBuilder sb = new StringBuilder();
	
		
        String line = "";
        while((line = reader.readLine()) != null) {
            sb.append(line + System.getProperty("line.separator"));
            if ( line.startsWith("energy") )
            	freeEnergy= line.split("energy: ")[1];
        }

        output= sb.toString();
        reader.close();

        proc.waitFor();
        
		} catch (IOException e) {
			e.printStackTrace();
			System.err.println(e); 
		} catch (InterruptedException e) { 
			e.printStackTrace();
			System.err.println(e); 
		}
		
	
		freeEnergy= freeEnergy.split(" k")[0];
		
		return freeEnergy;
    }
} 
