# -*- coding: utf-8 -*-
"""
Created on Fri Mar 25 12:29:28 2016

@author: Giovanni Renda, ICAR-CNR// 


bootstrap.py filemiRNA filemRNA mapsize alphas alphae epochs thrgeni offset thrcode threnergy -split numseqperfile
""" 
from mergefile import merge
from splitfile import split
from multiprocessing import Process , Lock , Value
import sys
import argparse
import os
count = Value('i', 0)

parser = argparse.ArgumentParser()

parser.add_argument('-filemirna', action='store', dest='filemiRNA',nargs=1,
                    help='microRNA fasta file')
parser.add_argument('-filemrna', action='store', dest='filemRNA',nargs=1,
                    help='mRNA fasta file')
parser.add_argument('-mapsize', action='store', dest='mapsize',nargs='+',
                    help='SOM size (size of squared mapsize) (e.g, 25)')
parser.add_argument('-alphas', action='store', dest='alphas',nargs='+',
                    help='SOM starting alpha parameter (e.g., 0.9)')
parser.add_argument('-alphae', action='store', dest='alphae',nargs='+',
                    help='SOM starting alpha parameter (e.g., 0.1)')
parser.add_argument('-epochs', action='store', dest='epochs',nargs='+',
                    help='number of epochs for SOM training. (e.g, 1000)')
parser.add_argument('-thrgeni', action='store', dest='thrgeni',nargs='+',
                    help='threshold parameter for mRNA projection (e.g, 0.5)')
parser.add_argument('-offset', action='store', dest='offset',nargs='+',
                    help='bulge offset (e.g, 3)')
parser.add_argument('-thrcode', action='store', dest='thrcode',nargs='+',
                    help='miRNA tail threshold distance (e.g, 0.8)')
parser.add_argument('-threnergy', action='store', dest='threnergy',nargs='+',
                    help='intaRNA free energy threshold. (e.g, -7)')
parser.add_argument('-split', action='store', default=0, dest='split',
                    help='[optional] Split mRNA input file into a number of files. This parameter indicates the number of genes for each file (e.g, 1000)')

results = parser.parse_args()
if not results.filemiRNA:
	print("problemi? bootstrap.py --help")
	sys.exit(64)

print("passo 1 in esecuzione ");
os.popen("java SOMTrainingHead "+results.filemiRNA[0]+" "+results.mapsize[0]+" "+results.alphas[0]+" "+results.alphae[0]+" "+results.epochs[0]);

#passo 2 

print("passo 2 in esecuzione ");
os.popen("java SOMProjectionMRNA SOMTrainingHead_"+results.mapsize[0]+"_"+results.alphas[0]+"_"+results.alphae[0]+".txt "+results.filemRNA[0]+" "+results.filemiRNA[0]+" "+results.mapsize[0]+" "+results.thrgeni[0]);

#passo 3
  
print("passo 3 in esecuzione ");
os.popen("java  -classpath \"lib/core-1.8.5.jar\":. CompareMRNA_MiRNATail "+results.filemRNA[0]+" "+results.filemiRNA[0]+" "+results.offset[0]+" "+results.thrcode[0]);

#passo 4

print("passo 4 in esecuzione ");
os.popen("java Create_mRNAmiRNA_list "+results.filemRNA[0]+" "+results.filemiRNA[0]+" TailConfirmedTargets_"+results.filemRNA[0]+"_th"+results.thrcode[0]+"_offset"+results.offset[0]+".txt");

#passo 5

def f(z,count,l,numFile):
  os.popen("java Calculate_mRNAmiRNA_MFE_list "+results.filemRNA[0]+" "+results.filemiRNA[0]+" Pairs_HeadTail_TailConfirmedTargets_"+results.filemRNA[0]+"_th"+results.thrcode[0]+"_offset"+results.offset[0]+".txt"+z+".txt "+results.threnergy[0]);
  print("fine numero "+z)
  l.acquire()
  count.value=count.value + 1
  print (count.value)
  if(count.value==numFile+1):
    merge(results,numFile)
  l.release()


print("passo 5 in esecuzione ");

if results.split[0]!=0:
  l = Lock()
  numFile=split("Pairs_HeadTail_TailConfirmedTargets_"+results.filemRNA[0]+"_th"+results.thrcode[0]+"_offset"+results.offset[0]+".txt",results.split);
  y=range(0,numFile+1)
  for i in y:
    Process(target=f, args=(str(i),count,l,numFile)).start()


        
else:
    os.popen("java Calculate_mRNAmiRNA_MFE_list "+results.filemRNA[0]+" "+results.filemiRNA[0]+" Pairs_HeadTail_TailConfirmedTargets_allmRNA_cel_3UTR_validated.fas_th"+results.thrcode[0]+"_offset"+results.offset[0]+".txt "+results.threnergy[0]);



